//Bystander class(s)
::BystanderRoleText <- function(target) {
	local gametext = SpawnEntityFromTable("game_text",{
			 	message 	= "You are a Bystander", 
			 	x 			= -1, 
			 	y 			= 0.25,
			 	holdtime 	= 5,
			 	channel 	= 1,
			 	fadein 		= 1,
			 	fadeout 	= 1.5,
			 	color 		= "100 100 100",
			 	color2 		= "240 110 0",
			 	})
	EntFireByHandle(gametext, "Display", "", 0, target, target)
	EntFireByHandle(gametext, "Kill", "", 10, target, target)
}

function NitWit(bystander) {
	bystander.ValidateScriptScope()
	bystander.GetScriptScope().MyRole 	<- "Bystander"
	bystander.GetScriptScope().MyClass 	<- "NitWit"
	bystander.GetScriptScope().MyPartCount <- 0
	AddThinkToEnt(bystander, null)
	//bystander.ForceChangeTeam(2, true)
	bystander.Regenerate(true)
	local slot_0 = NetProps.GetPropEntityArray(bystander, "m_hMyWeapons", 0) //gun
	local slot_1 = NetProps.GetPropEntityArray(bystander, "m_hMyWeapons", 1) 	//knife
	local slot_2 = NetProps.GetPropEntityArray(bystander, "m_hMyWeapons", 2) 	//sapper
	local slot_3 = NetProps.GetPropEntityArray(bystander, "m_hMyWeapons", 3) //pda
	local slot_4 = NetProps.GetPropEntityArray(bystander, "m_hMyWeapons", 4) 	//invis

	local weplist = ["tf_weapon_builder", "tf_weapon_sapper"]
	for (local i = 0; i < 7; i++){
        local heldWeapon = NetProps.GetPropEntityArray(bystander, "m_hMyWeapons", i);
        if (heldWeapon == null) {}
		else if (heldWeapon.GetName() == "tf_weapon_builder") {bystander.Weapon_Switch(heldWeapon)}
		else if (heldWeapon.GetName() == "tf_weapon_sapper") {bystander.Weapon_Switch(heldWeapon)}
		else {heldWeapon.Destroy()}
    }


	local bystandercosmetic = null
	while(bystandercosmetic = Entities.FindByClassname(bystandercosmetic, "tf_wearable")){
		if (bystandercosmetic.GetOwner() == bystander){
			bystandercosmetic.SetTeam(2)
		}
	}
	BystanderRoleText(bystander)
}